	list	P=PIC12F629		
 
	#include	<P12F629.INC>
 __config _PWRTE_ON  &_MCLRE_OFF &_WDT_OFF &_INTRC_OSC_NOCLKOUT &_CP_ON &_CPD_OFF &_BODEN_OFF

;  EEPROM
		ORG 	0X00002100
		DATA  	0X2, .1, .2, .3, .4, .5 ;(     )
		data	0x0			;   (0 - , 1 - )
		DE		" sprinter4wd.narod.ru "
;   ID
		__IDLOCS		H'0203'	 ; 

;	  

Reg_1		equ    	20h ;   
Reg_2		equ    	21h	; 
Reg_3		equ		22h	;  ()

REGGPIO		equ     23h ;     GPIO REG_GPIO

TEMP_W		equ		24h	;   W   
TEMP_STATUS	equ 	25h	;      

PLM_OFF		equ		26h	;    ( )
PLM_ON		EQU		27H	;    ( )
PLM_OFF_TMP	EQU		28H	;ר  ( )
PLM_ON_TMP	EQU		29H	;ר  ( )

;    
ZDRV		equ    	2Ah 
COUNTER		equ    	2Bh
;COUNTER2 	equ		2Ch
;z31			equ		2Dh
;z32			equ		2Eh
;z21			equ		2Fh
;z22			equ		30h

;COUNT_TMR1L	equ		31h
;COUNT_TMR1H	equ		32h
FLAGS		EQU		33H ;  7-   ; 0-; 1- ; 2-
;ZADL		EQU		34H	;   
ZAD2		EQU		35H	;   (     )
ZAD			EQU		36H	;   (  )
LOW_COUNT	EQU		37H	;     
HIGH_COUNT	EQU		38H ;     
TEMP_EEPROM	EQU		39H	;      EEPROM
PARK		EQU		3AH	;      (00h  01h)
ADR_EE		EQU		3BH	;       EEPROM


;   
;pause31		equ		15h ; ;
;pause32		equ		01H ;15h -  6 , 29h -  10 
;pause21 	equ		06h ; 
;pause22 	equ		01h ; 2 
SWITCHING_LOW_BEAM	EQU .5	;        ,     
SWITCHING_HIGH_BEAM	EQU	.2	;        ,     
WINDOW_SWITCHING_TIME	EQU	.31 ;       /       (*0,0655)
SHIM_ON_TIME	EQU	.15 ;    
END_OF_EEPROM		equ	06h	;     EEPROM +1 
W			equ		0	;  
F			EQU		1	;  	
Z			EQU		2	;  ZERRO

;	 :

;7	-GP0-   MOS FET 1-, 0-
MOSFET		EQU		0
;6 	-GP1-   
;SOUND		EQU		1
LED			equ		1
;5 	-GP2-     1-, 0- ( - ,       )
PARK_SWITCH	EQU		2
;4 	-GP3-   "" ("0"-)
LOW_BEAM	EQU		3
;3 	-GP4-   ("1"-ON) 
;IGNITION	EQU		4
;2 	-GP5-    0-  , 1- 
HIGH_BEAM	EQU		5
;1  -VDD- +5V
;8  -VSS- GND

			org 	0
			;	  

			GOTO 	nachalo

			org		4
			;

			movwf	TEMP_W		;  _
			SWAPF	STATUS,W	;  _
			movwf	TEMP_STATUS	;  STATUS
;_____________________________ 
;\/ \/ \/ \/ \/ \/ \/ \/ \/ \/
			;   
			BTFSC	PIR1, 0		;   TMR1 ?
			GOTO 	INT_TMR1	; !   TMR1
			; .   ( TMR0)
SHIM_RABOTA:
			MOVF	PLM_OFF_TMP,F	;  
			BTFSC	STATUS,Z
			GOTO 	ZERO1 		;, 
			; 
			NOP					;   4 
			NOP					;      
			NOP					;   
			NOP					; 
			BCF		GPIO, MOSFET	;<<<<<<<<<<<<  >>>>>>>>>>>>>>>>
			DECF	PLM_OFF_TMP,F

	;		MOVF	PLM_OFF_TMP,F	;  
	;		BTFSC	STATUS,Z
	;		GOTO 	WIHOD 		;, 
			BCF		FLAGS, HIGH_BEAM	;   
			btfsc	GPIO, HIGH_BEAM
			BsF		FLAGS, HIGH_BEAM	;   
			
			GOTO 	WIHOD
ZERO1:
			MOVF	PLM_ON_TMP,F	;  
			BTFSC	STATUS,Z
			GOTO	ZERO2		;, 
			; 
			BSF		GPIO, MOSFET	;<<<<<<<<<<<<<  >>>>>>>>>>>>>>
			DECF	PLM_ON_TMP,F
			GOTO	WIHOD
ZERO2: 		; ר, ..  ר 
			MOVF	PLM_OFF,W
			MOVWF	PLM_OFF_TMP
			MOVF	PLM_ON,W
			MOVWF	PLM_ON_TMP
			GOTO	SHIM_RABOTA		;?  Ĩ !

INT_TMR1:
;			INCF	COUNT_TMR1L, F	;   ר TMR1
;			BTFSC	STATUS, Z		;   
;			INCF	COUNT_TMR1H, F	;   ר TMR1   
			MOVF	ZAD, F			;   
			BTFSS	STATUS, Z		; ?
			DECF	ZAD, F			;  ,   ר

			MOVF	ZAD2, F			;   
			BTFSS	STATUS, Z		; ?
			DECF	ZAD2, F			;  ,   ר

			BCF		PIR1, 0			;   TMR1
			GOTO	WIHOD2			;     TMR1
;/\ /\ /\ /\ /\ /\ /\ /\ /\ /\
;_____________________________   
WIHOD:
			BCF		INTCON,2	;  T0IF   INTCON ( , Ĩ )
WIHOD2:
			SWAPF	TEMP_STATUS,W	;    _
			MOVWF	STATUS			;   STATUS_
			SWAPF	TEMP_W,F		;   
			SWAPF	TEMP_W,W		;   STATUS ( SWAPF          MOVF)
			RETFIE					;


;--------------------------------------------------------------------------
;	      

nachalo:
			BCF		STATUS,RP0	;  0
			CLRF	GPIO
			MOVLW	b'00000111'
			MOVWF	CMCON		;   
			CLRF	INTCON		;  
			CLRWDT				;     
			BSF		STATUS,RP0 	;  1
			MOVLW	B'10000001'
			MOVWF	OPTION_REG	;   
			;bit 7=1			 
			;bit 5=0			    TMR0 - 
			;bit 3=0			   TMR0
			;bits 2-0=001		   1:4
			MOVLW	b'00101100'
			MOVWF	TRISIO 		;  0-1, 4  GPIO    ,    3-5   (3     )
		;	clrf	H'009F'		; ANSEL		;  pic12f675
		;	movlw	b'00010000'
			CALL	0X3FF 		;  
			MOVWF	OSCCAL 		;     

			MOVLW	B'00000001'
			MOVWF	PIE1		;       TMR1

			BCF		STATUS,RP0	;  0

			BSF		INTCON, 7	;     (     )
	
			;  

			CLRF	PLM_ON_TMP		;  ר_
			CLRF	PLM_OFF_TMP		;_

			BSF 	STATUS, RP0		
			;   EEPROM  
			MOVLW	END_OF_EEPROM	; 
			MOVWF	EEADR			; 
			BSF		EECON1, RD		; 
			MOVF	EEDATA, W		;
			MOVWF	PARK			; 
			; __EEPROM__ ר
			CLRW					; 
			MOVWF	EEADR			; 
			BSF		EECON1, RD		; 
			MOVF	EEDATA, W		; 
			BTFSS	STATUS, Z		;   
			;  ,  ר  (  )
			GOTO	NEXT_STEP01		;  ,  
			;  -  ר
			BCF 	STATUS, RP0		;  0
			CLRF	PLM_ON			; ר_
			CLRF	PLM_OFF			;_
			GOTO	NEXT_STEP02
NEXT_STEP01:
			MOVWF	EEADR			; __EEPROM____
			BSF		EECON1, RD		; ר_
			MOVF	EEDATA, W		; ._
			BCF 	STATUS, RP0		;   _
			MOVWF	PLM_ON			; ר_
			MOVLW	.10				; _
			MOVWF	PLM_OFF			; _
			MOVF	PLM_ON, W		;  _
			SUBWF	PLM_OFF, F		; 10-(   ר)
NEXT_STEP02:

;			CLRF	ZADL
;			CLRF	ZADH
			CLRF	ZAD
			MOVLW	SHIM_ON_TIME ;.46			;   1 
			movwf	ZAD2
			clrf	COUNTER
			CLRF	FLAGS
			CLRF	LOW_COUNT
			CLRF	HIGH_COUNT
;			CLRF	COUNT_TMR1L	;   ר  TMR1
;			CLRF	COUNT_TMR1H	;   ר  TMR1
			CLRF	TMR1H		;    TMR1
			CLRF	TMR1L		;    TMR1
			MOVLW	B'00000001'	;  TMR1
			; 5-4 -  0
			; 2 - 
			; 1 -    
			; 0 -  
			MOVWF	T1CON		;  
			BSF		INTCON, 6	;      TMR1

;__________________________________________________________________________________
;   led  -  
;	CALL  	SIGNAL; 
	CALL  	DELAY;  
	BSF  	GPIO, LED
	CALL  	DELAY
	BcF  	GPIO, LED
	CALL  	DELAY

	BSF  	GPIO, LED
	CALL  	DELAY
	BcF  	GPIO, LED

;	CALL  	SIGNAL; 
	CALL  	DELAY;


START_MAIN:
	CLRWDT
;----------------
	MOVF 	GPIO, W    	; GPIO  W
	ANDLW 	b'00101100' ;   and b'00101100'
	MOVWF 	REGGPIO 	;  W  REG_GPIO
	CALL	PROV_BEAM2	; Ĩ    ,       REGGPIO 
	bcf 	STATUS, C  	;  
	RRF 	REGGPIO,F 	;   
	RRF 	REGGPIO,F 	;   
	MOVF	PARK, W		;   
	XORWF	REGGPIO, F	;    

;  case else
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                ;case (01H)	++
	MOVf 	REGGPIO,W ;  W  
	SUBLW 	0x01      ;   W
	BTFSC 	STATUS,Z ;  zerro
	CALL 	CHECK_PROGRAM135     ;    CHECK_PROGRAM135

	btfsc	FLAGS, 6
	goto 	PROGRAMMING_MAIN	;       

               ;case (03H)	+++
	MOVf 	REGGPIO,W ;  W  
	SUBLW 	0x03      ;   W
	BTFSC 	STATUS,Z ;  zerro
	CALL 	CHECK_PROGRAM2     ;    CHECK_PROGRAM2

               ;case (09H)	+++
	MOVf 	REGGPIO,W ;  W  
	SUBLW 	0x09      ;   W
	BTFSC 	STATUS,Z ;  zerro
	CALL 	CHECK_PROGRAM4     ;    CHECK_PROGRAM4
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  




	INCF	PLM_ON, W	;   FF
	BTFSC	STATUS, Z
	GOTO	START_MAIN	; Ĩ  , ..  
		


             ;case  (00H)
	MOVf 	REGGPIO,W ;  W  
	BTFSC 	STATUS,Z ;  zerro
	GOTO 	ZZUM3     ;    ZZUM3

               ;case (0aH, 0bH)
	MOVf 	REGGPIO,W ;  W  
	ANDLW 	0xFE      ; 
	xorlw	0x0a      ;
	BTFSC 	STATUS,Z ;  zerro
	GOTO 	ZZUM2     ;    ZZUM2
  
               ;case (01H)
	MOVf 	REGGPIO,W ;  W  
	xorLW 	0x01      ;
	BTFSC 	STATUS,Z ;  zerro
	GOTO 	ZZUM2     ;    ZZUM2

               ;case (09h)
	MOVf 	REGGPIO,W ;  W  
	xorLW 	0x09      ;
	BTFSC 	STATUS,Z ;  zerro
	GOTO 	ZZUM2     ;    ZZUM2

               ;case  (02H-03H)
	MOVf 	REGGPIO,W ;  W  
	ANDLW 	0xFe      ;   
	xorlw	0x02      ;
	BTFSC 	STATUS,Z  ;  zerro
	GOTO 	ZZUM2     ;    ZZUM2

               ;case (08h)
	MOVf 	REGGPIO,W ;  W  
	xorLW 	0x08      ;
	BTFSC 	STATUS,Z ;  zerro
	GOTO 	ZZUM2     ;    ZZUM2



;	CALL 	DELAY     ;
;	CALL 	DELAY     ;
	GOTO 	START_MAIN        ;  

;______________________________________________________________________________________________________________________________________________
CHECK_PROGRAM135: ;
			BTFSC	FLAGS, 1	;    
			GOTO	LOWON 		; LOWON
			;LOWOFF

			BTFSC	FLAGS, 2	;    
			GOTO	HIGHON		; HIGHON
			;HIGHOFF

			BCF		FLAGS, 1 	;   
			BCF		FLAGS, 2 	;   
			BTFSC	FLAGS, 0 	;       ?
			RETURN	;GOTO 	INITIAL_INTERVAL:		; , 
			BSF		FLAGS, 0 	;  ,   
			CALL	PAUSE006	;    0.06 


INITIAL_INTERVAL:	;  
			MOVLW	WINDOW_SWITCHING_TIME ;.46			;   3 
			MOVWF	ZAD			; ب ר
			RETURN

LOWON:		; 
			BCF		FLAGS, 1 	;   
			BCF		FLAGS, 2 	;   
			CLRF	HIGH_COUNT
			; 
			MOVF	ZAD, F		;  
			BTFSC	STATUS, Z	; ?
			;   Ҩ,    ר  
			;   ר   
			GOTO 	CLEANING_ZAZ; .  Ҩ.  Ѩ.
			INCF	LOW_COUNT, F;  ,   Ҩ,  ר
			RETURN
HIGHON:		; 	
			BCF		FLAGS, 1 	;   
			BCF		FLAGS, 2 	;   
			; 
			MOVF	ZAD, F		;   
			BTFSC	STATUS, Z	; ?
			;   Ҩ,    ר  
			;   ר  
			GOTO 	CLEANING_H	; .  Ҩ.  Ѩ.
			INCF	HIGH_COUNT, F;  ,   Ҩ,  ר
			; ר .  <>{SWITCHING_LOW_BEAM}    ר
			MOVF	LOW_COUNT,W	;
			SUBLW	SWITCHING_LOW_BEAM			; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			BTFSS	STATUS, Z
			GOTO	CLEANING_H	; <>5
			; =5 
			
			;  ר ,  < {SWITCHING_HIGH_BEAM}  .  >{SWITCHING_HIGH_BEAM}    ר
			MOVF	HIGH_COUNT,W	;
			SUBLW	SWITCHING_HIGH_BEAM			; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			BTFSC	STATUS, Z
			GOTO 	PROGRAMMING				; ={SWITCHING_LOW_BEAM}.    
			BTFSS	STATUS, 0
			GOTO	CLEANING_H	; >{SWITCHING_HIGH_BEAM}
			RETURN				; <{SWITCHING_HIGH_BEAM}
CLEANING_ZAZ:
			CLRF	LOW_COUNT
			incf	LOW_COUNT, F
			CLRF	HIGH_COUNT
			GOTO 	INITIAL_INTERVAL

CLEANING_H:
			CLRF	LOW_COUNT
			CLRF	HIGH_COUNT
			incf	HIGH_COUNT, F
			GOTO 	INITIAL_INTERVAL

CHECK_PROGRAM2: ;
			BCF		FLAGS, 0 	;   
			BCF		FLAGS, 2 	;   
			BTFSC	FLAGS, 1 	;   ON   ?
			GOTO 	METKA61		; ON, 
			BSF		FLAGS, 1 	; OFF,  
			CALL	PAUSE006	;    0.06 
METKA61:
			RETURN

CHECK_PROGRAM4: ;
			BCF		FLAGS, 1 	;   
			BCF		FLAGS, 0 	;   
			BTFSC	FLAGS, 2 	;       ?
			GOTO 	METKA71		; ON, 
			BSF		FLAGS, 2 	; OFF,  
			CALL	PAUSE006	;    0.06 
METKA71:
			RETURN
;______________________________________________________________________________________________________________________________________________
PROGRAMMING:
			bsf 	FLAGS, 6	;       
			return

PROGRAMMING_MAIN:	;  
;			CALL  	SIGNAL;  
;			CALL  	SIGNAL; 
;			CALL  	SIGNAL; 
;			CALL  	SIGNAL; 
;			CALL  	SIGNAL; 
			MOVLW	.5				;      50%
			MOVWF	PLM_OFF			; 
			MOVWF	PLM_ON			; 

			call	PROG_SHIM_ON
			CALL  	DELAY;
			CALL  	DELAY;
			CALL  	DELAY;
			CALL  	DELAY;
			CALL  	DELAY;
			call	PROG_SHIM_OFF
			CALL  	DELAY;
			CALL  	DELAY;
			CALL  	DELAY;
			CALL  	DELAY;
			CALL  	DELAY;

			; __EEPROM__ 
			BSF 	STATUS, RP0		
			CLRW					; 
			MOVWF	EEADR			; 
			BSF		EECON1, RD		; 
			MOVF	EEDATA, W		; 
			BCF 	STATUS, RP0		
			MOVWF	TEMP_EEPROM		;     EEPROM
			CALL	BEEP_BEEP

CYCL_PROGR:
			MOVF 	GPIO, W    	; GPIO  W
			ANDLW 	b'00101100' ;   and b'00111100'
			MOVWF 	REGGPIO 	;  W  REG_GPIO
			CALL	PROV_BEAM2	; Ĩ    ,       REGGPIO 
			bcf 	STATUS, C  	;  
			RRF 	REGGPIO,F 	;   
			RRF 	REGGPIO,F 	;   
			MOVF	PARK, W		;   
			XORWF	REGGPIO, F	;    

;  case else
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                ;case (01H)	+ (+)
			MOVf 	REGGPIO,W ;  W  
			xorLW 	0x01      
			BTFSC 	STATUS,Z ;  zerro
			CALL 	PROGRAM135     ;    PROGRAM135

               ;case (02H)	++
			MOVf 	REGGPIO,W ;  W  
			ANDLW 	0xFE      ; 
			xorLW 	0x02      
			BTFSC 	STATUS,Z ;  zerro
			CALL 	PROGRAM2     ;    PROGRAM2

               ;case (08H)	++
			MOVf 	REGGPIO,W ;  W  
			ANDLW 	0xFE      ; 
			SUBLW 	0x08      ;   W
			BTFSC 	STATUS,Z ;  zerro
			CALL 	PROGRAM3     ;    PROGRAM3

             ;case  (00H) -
			MOVf 	REGGPIO,W ;  W  
			BTFSC 	STATUS,Z ;  zerro
			GOTO 	PROGRAM_EXIT ;    

			GOTO 	CYCL_PROGR
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

PROGRAM135: ;
			BTFSC	FLAGS, 1	;    
			GOTO	PROGLOWON 		; LOWON
			;LOWOFF

			BTFSC	FLAGS, 2	;    
			GOTO	PROGHIGHON		; HIGHON
			;HIGHOFF

			BCF		FLAGS, 1 	;   
			BCF		FLAGS, 2 	;   
			BTFSC	FLAGS, 0 	;       ?
			RETURN	;GOTO 	INITIAL_INTERVAL:		; , 
			BSF		FLAGS, 0 	;  ,   
			CALL	PAUSE006	;    0.06 
			RETURN
PROGLOWON:	;    
			BCF		FLAGS, 1 	;   
			; 
			INCF	TEMP_EEPROM, F ; 
			MOVLW	END_OF_EEPROM
			SUBWF	TEMP_EEPROM, W	;   ={END_OF_EEPROM},   
			BTFSC	STATUS, Z		; ={END_OF_EEPROM}?
			CLRF	TEMP_EEPROM		; . 
			CALL 	BEEP_BEEP
			RETURN

PROGHIGHON:	;  
			BCF		FLAGS, 2 	;   
			MOVLW	0X01		;  
			XORWF	PARK, F		;   
			CALL 	BEEP_BEEP2
			RETURN

PROGRAM2: ;
			BCF		FLAGS, 0 	;   
;			BCF		FLAGS, 2 	;   
			BTFSC	FLAGS, 1 	;   ON   ?
			GOTO 	METKA81		; ON, 
			BSF		FLAGS, 1 	; OFF,  
			CALL	PAUSE006	;    0.06 
METKA81:
			RETURN

PROGRAM3: ;
;			BCF		FLAGS, 1 	;   
			BCF		FLAGS, 0 	;   
			BTFSC	FLAGS, 2 	;       ?
			GOTO 	METKA83		; ON, 
			BSF		FLAGS, 2 	; OFF,  
			CALL	PAUSE006	;    0.06 
METKA83:
			RETURN

BEEP_BEEP:
			call	PROG_SHIM_ON
			CALL	DELAY
			CALL	DELAY
;			CALL	SIGNAL
;			CALL	SIGNAL
			call	PROG_SHIM_OFF
			MOVF	TEMP_EEPROM, W
			BTFSC	STATUS,Z
			RETURN
			MOVWF	COUNTER
METKA82:
			CALL	DELAY
			CALL	DELAY
			call	PROG_SHIM_ON
			CALL	DELAY
;			CALL	SIGNAL
			call	PROG_SHIM_OFF
			DECFSZ	COUNTER, F
			GOTO	METKA82
			RETURN

BEEP_BEEP2:	;  -  ,  -  
			call	PROG_SHIM_ON
			CALL	DELAY
;			CALL 	SIGNAL	;   
			call	PROG_SHIM_OFF
			BTFSC 	PARK, 0 ;   (  ),   ٨  
			CALL 	DELAY
			BTFSC 	PARK, 0 ;   (  ),  ٨  
			call	PROG_SHIM_ON
			CALL	DELAY
;			CALL 	SIGNAL	
			call	PROG_SHIM_OFF
			CALL	DELAY	;   
			RETURN
;______________________________________________________________________________________________________________________________________________
;       ר  .     
PROV_BEAM2:
			BTFSC	INTCON,5 		;  T0IE 1-   TMR0 ,    ,   
			GOTO	CHECK_ON_SHIM		;  ,   -  
			; ,   
;			BTFSS	GPIO, HIGH_BEAM		;     1-OFF, 0-ON
			BsF		REGGPIO, HIGH_BEAM	;   
			BTFSs	GPIO, HIGH_BEAM		;     0-OFF, 1-ON
;			GOTO 	BIT2ON_REGGPIO	; 1- -    REGGPIO
			;   -    REGGEPIO
			BCF		REGGPIO, HIGH_BEAM	;   
			RETURN

CHECK_ON_SHIM:
		;	BSF			REGGPIO, HIGH_BEAM	;   



	;       		BcF			REGGPIO, HIGH_BEAM	;   
	;       		btfsc	FLAGS, HIGH_BEAM
BIT2ON_REGGPIO:
	;       		BsF		REGGPIO, HIGH_BEAM
			BcF		REGGPIO, HIGH_BEAM
			RETURN
;______________________________________________________________________________________________________________________________________________
			;   0.06 . 
;delay = 60'000 machine cycles
PAUSE006:
			movlw       .225
            movwf       Reg_1
            movlw       .78
            movwf       Reg_2
wr2         decfsz      Reg_1, F
            goto        wr2
            decfsz      Reg_2, F
            goto        wr2
			RETURN	;
;______________________________________________________________________________________________________________________________________________
;______________________________________________________________________________________________________________________________________________
;   
PROG_SHIM_ON:
			CALL 	DELAY			;     
			MOVF	PLM_OFF,F		;  
			BTFSS	STATUS,Z
			GOTO 	SHIM_ON	;   -  , .. 
			MOVF	PLM_ON,F		;  
			BTFSC	STATUS,Z
			RETURN	;  - , ..   
SHIM_ON:
			BSF		INTCON, 5		;     TMR0 ( ON)
;			MOVLW	B'10100000'		;
;			MOVWF	INTCON			; 
			BSF		GPIO, LED		;  LED
			RETURN

;   
PROG_SHIM_OFF:
			;CLRF	INTCON			;  OFF
			BCF		INTCON, 5		;  OFF
			BCF		GPIO, MOSFET	;  MOSFET
			BCF		GPIO, LED		;  LED
			RETURN


;---------------
ZZUM2:
;	goto ZZUM3
	BTFSC	INTCON,5 		;   T0IE 1-   TMR0 ,    ,   
	CALL 	PROG_SHIM_OFF	;  ,  

endzzum2:
	MOVLW	SHIM_ON_TIME ;.46			;   1 
	MOVWF	ZAD2			; ب ר
	CALL  	DELAY		;
	GOTO  	START_MAIN	;
;----------------

;---------------
ZZUM3:
	BTFSc	INTCON,5 		;   T0IE 1-   TMR0 ,    ,   
	goto	endzzum3
;	CALL  	DELAY		;
;	CALL  	DELAY		;
;	CALL  	DELAY		;
	MOVF	ZAD2, F		;  
	BTFSC	STATUS, Z	; ?
	CALL 	PROG_SHIM_ON	;     ,  

endzzum3:
	CALL  	DELAY		;
	GOTO  	START_MAIN	;
;----------------


;-------------------------------------------------------------------------------
;   250 
DELAY:
			movlw       .169
            movwf       Reg_1
            movlw       .69
            movwf       Reg_2
            movlw       .2
            movwf       Reg_3
wr          decfsz      Reg_1, F
            goto        wr
            decfsz      Reg_2, F
            goto        wr
            decfsz      Reg_3, F
            goto        wr
            nop
            nop
			return
;-------------------------------------------------------------------------
PROGRAM_EXIT:
		;   EEPROM  
		BSF			STATUS, RP0				; 1
		MOVLW		END_OF_EEPROM	; 
		MOVWF		EEADR			; 
		BSF			EECON1, RD		; 
		MOVF		EEDATA, W		;
		BCF			STATUS, RP0				; 0
		;
		SUBWF		PARK, W
		BTFSC		STATUS, Z		;   ,      ,  Ĩ 
		GOTO		PRGEXT1			;   
		;    
		MOVLW		END_OF_EEPROM
		MOVWF		ADR_EE			;   
		MOVF		PARK, W	;  
		CALL		WriteEE
PRGEXT1:
		;   EEPROM  
		BSF			STATUS, RP0				; 1
		CLRW						; 
		MOVWF		EEADR			; 
		BSF			EECON1, RD		; 
		MOVF		EEDATA, W		;
		BCF			STATUS, RP0				; 0
		;
		SUBWF		TEMP_EEPROM, W
		BTFSC		STATUS, Z		;   ,      ,  Ĩ 
		GOTO		PRGEXT2			;   
		;    
		CLRW
		MOVWF		ADR_EE			;   
		MOVF		TEMP_EEPROM, W	; 
		CALL		WriteEE
PRGEXT2:
		call		PROG_SHIM_ON
		CALL		DELAY
		CALL		DELAY
		CALL		DELAY
;		CALL		SIGNAL			;       
;		CALL		SIGNAL		
;		CALL		SIGNAL		
		call		PROG_SHIM_OFF
		CALL		DELAY
		CALL		DELAY
		CALL		DELAY
		GOTO 		nachalo

WriteEE:
    	bsf     	STATUS    , RP0
    	movwf    	EEDAT
    	movF    	ADR_EE, W				; 
    	movwf    	EEADR
    	bsf        	EECON1,WREN         ;Enable write
    	bcf        	INTCON, GIE         ;Disable INTs
    	btfsc    	INTCON, GIE         ;See AN576
    	goto    	$-2 
    	movlw     	0x55                ;Unlock write
    	movwf     	EECON2 
    	movlw     	0xAA
    	movwf     	EECON2 
    	bsf     	EECON1, WR          ;Start the write
WaitForEEWrite
    	btfsc   	EECON1, WR          ;wait for hardware to clear (done writing)
    	goto    	WaitForEEWrite
    	bcf     	STATUS    , RP0     ;Bank0
;    	bsf     	INTCON, GIE         ;Enable INTS
		RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	END

;__________________________________________________________________________________
